using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace HeuristicLab.Services.Optimization.Web {
  public static class Constants {
    public const string DiagnosticsConnectionString = "Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString";
  }

  public class WebRole : RoleEntryPoint {
    public override bool OnStart() {
      // For information on handling configuration changes
      // see the MSDN topic at http://go.microsoft.com/fwlink/?LinkId=166357.      
      try {
        if (!String.IsNullOrEmpty(RoleEnvironment.GetConfigurationSettingValue(Constants.DiagnosticsConnectionString))) {
          DiagnosticMonitorConfiguration dmc = DiagnosticMonitor.GetDefaultInitialConfiguration();
          dmc.Logs.ScheduledTransferPeriod = TimeSpan.FromMinutes(1);
          dmc.Logs.ScheduledTransferLogLevelFilter = LogLevel.Verbose;
          DiagnosticMonitor.Start(Constants.DiagnosticsConnectionString, dmc);
        }
      }
      catch (RoleEnvironmentException ex) {
        // diagnostics connection string not in configuration
        // -> diagnostics disabled
        // nothing more to do
      }

      return base.OnStart();
    }
  }
}
